package com.simuwang.manage.service.impl;

import com.simuwang.base.common.support.MybatisPage;
import com.simuwang.base.mapper.daq.FileManageMapper;
import com.simuwang.base.pojo.dos.FileManageDO;
import com.simuwang.base.pojo.dto.query.FileManagePageQuery;
import com.simuwang.base.pojo.vo.FileManageVO;
import com.simuwang.base.pojo.vo.SourceTypeVO;
import com.simuwang.manage.service.FileMangeService;
import com.simuwang.shiro.utils.UserUtils;
import com.smppw.common.pojo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.stream.Collectors;

/**
 * FileName: FileMangeServiceImpl
 * Author:   chenjianhua
 * Date:     2024/12/19 14:03
 * Description: ${DESCRIPTION}
 */
@Service
public class FileMangeServiceImpl implements FileMangeService {

    @Autowired
    private FileManageMapper fileManageMapper;

    @Override
    public MybatisPage<FileManageVO> searchFileManage(FileManagePageQuery fileManagePageQuery) {
        List<FileManageDO> fileManageDOList = fileManageMapper.searchFileManage(fileManagePageQuery);
        List<FileManageVO> fileManageVOList = fileManageDOList.stream().map(FileManageDO::toVO).collect(Collectors.toList());
        long total = fileManageMapper.countFileManage(fileManagePageQuery);
        return MybatisPage.of(total,fileManageVOList);
    }

    @Override
    public ResultVo uploadFile(MultipartFile file, String fundId, String fileType, String fileDate) {
        return null;
    }

    @Override
    public FileManageVO getFileByFileId(Integer fileId) {
        FileManageDO fileManageDO = fileManageMapper.getFileInfoByFileId(fileId);
        return fileManageDO.toVO();
    }

    @Override
    public void changeFileSourceType(SourceTypeVO sourceTypeVO) {
        List<Integer> fileIdList = sourceTypeVO.getFileIdList();
        Integer fileType = sourceTypeVO.getFileType();
        Integer userId = UserUtils.getLoginUser().getUserId();
        fileManageMapper.changeFileSourceType(fileIdList,fileType,userId);
    }
}
